package ve.gob.cenditel.tibisaymovil;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.util.ArrayList;

import ee.sk.digidoc.DataFile;
import ee.sk.digidoc.Signature;
import ee.sk.digidoc.SignedDoc;
import ee.sk.digidoc.factory.DigiDocFactory;
import ee.sk.utils.ConfigManager;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.View;
import android.view.ViewGroup;
import android.view.Window;
import android.view.View.OnClickListener;
import android.webkit.MimeTypeMap;
import android.widget.AdapterView;
import android.widget.BaseAdapter;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

public class BDOCVerifyResultActivity extends Activity {

	
   
	
	// linear
	private LinearLayout button_share;
    private LinearLayout button_finish;
    private ListView documents_list;
    
    // cadena que mantiene la ruta para almacenar los archivos
    // extraidos de un contendor BDOC
    private String extractedDirFiles;
    
    // ruta absoluta al archivo a verificar
    private String fileToVerify;
    
    // extension del archivo a verificar
    private String fileToVerifyExtension;

    
    // mimetype del archivo a verificar
    private String mimeTypeFileToVerify;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		
		//Estilando la barra de titulo
		final boolean customTitleSupported = requestWindowFeature(Window.FEATURE_CUSTOM_TITLE);
		Log.d("onCreate", "antes de super");
		super.onCreate(savedInstanceState);		
		
		setContentView(R.layout.activity_verify_result_bdoc);
		
		//Estilando Barra de titulo
		if(customTitleSupported)
			getWindow().setFeatureInt(Window.FEATURE_CUSTOM_TITLE, R.layout.title_bar);
		
		button_share = (LinearLayout) this.findViewById(R.id.button_share_zone);
        button_finish = (LinearLayout) this.findViewById(R.id.button_finish_zone);
        
        Bundle bundle=getIntent().getExtras();
		fileToVerify = bundle.getString("fileToVerify");
		fileToVerifyExtension = bundle.getString("fileExtension"); 
		mimeTypeFileToVerify = getMimeType(fileToVerify);
		
		if (fileToVerifyExtension.equals("bdoc")){
			// ejecutar la verificacion	        
			doBdocVerification(fileToVerify);
		}else{
			Toast.makeText(getApplicationContext(), "¡Por Implementar!", Toast.LENGTH_SHORT).show();
			
		}
			
		
        
        button_finish.setOnClickListener(new OnClickListener() 
        {        
            public void onClick(View v) 
            {
            	
            	Intent oIntent = new Intent(BDOCVerifyResultActivity.this, TibisayMovilActivity.class);
		        oIntent.setAction(Intent.ACTION_VIEW);
		        oIntent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
		        startActivity(oIntent);
		        
		        finish();
            }
        });
        
        button_share.setOnClickListener(new OnClickListener() 
        {        
            public void onClick(View v) 
            {
            	shareIt();
            }
        });
        
        
	}
	
	
	
	
	
	
	// funcion para verificar un documento
	private void doBdocVerification(String absolutePathFileToVerify){
		
		try {
			Log.d("doBdocVerification:", "Inicializando jdigidoc ...");
	    	ConfigManager.init("jar://jdigidoc.cfg");
			Log.d("despues de:", "ConfigManager.init");
			
			Log.d("antes de:", "digFac");
			DigiDocFactory digFac = ConfigManager.instance().getDigiDocFactory();
			
			Log.d("getFilesDir:", getFilesDir().getAbsolutePath());
			
			Log.d("PATH", Environment.getExternalStorageDirectory().toString());
			
			File file = new File(absolutePathFileToVerify);
        	InputStream selectedFile = null;
        	selectedFile = new BufferedInputStream(new FileInputStream(file));
			
        	SignedDoc sdoc = digFac.readSignedDocFromStreamOfType(selectedFile, true);		    
        	selectedFile.close();
		    
        	//SignedDoc sdoc = digFac.readSignedDocFromStreamOfType(fraw, true);		    
		    Signature signature = sdoc.getSignature(0);
		    	
		    // TextView para colocar el resultado de la firma
		    TextView signatureVerificationResult = (TextView) findViewById(R.id.archivo_para_firmar_path);
		    
		    
		    // array de excepciones lanzadas al verificar firmas
		    ArrayList arraySignaturesErrors = null;
		    
		    // array de strings para almanecenar los errores de firmas
		    ArrayList<String> signatureVerificationErrors = new ArrayList<String>();
		    
		    // verificar cada una de las firmas del contenedor
		    for (int i = 0; i < sdoc.countSignatures(); i++){
		    	Signature tmpSignature = sdoc.getSignature(i);
		    	arraySignaturesErrors = new ArrayList();
		    	arraySignaturesErrors = tmpSignature.verify(sdoc, false, false);
		    	Log.d("****i:"+i,"arraySignaturesErrors.size: "+ arraySignaturesErrors.size());
		    	
		    	for (int j = 0; j < arraySignaturesErrors.size(); j++){
		    		
		    		signatureVerificationErrors.add("Firma "+Integer.toString(i+1)+ ": "+
		    		arraySignaturesErrors.get(j).toString() + "\n");
		    		
		    		Log.d("****signatureVerificationErrors", 
		    				"Firma "+Integer.toString(i+1)+ ": "+
				    		arraySignaturesErrors.get(j).toString() + "\n");
		    		Log.d("signatureVerificationErrors: ", signatureVerificationErrors.get(j).toString());
		    	}
		    	
		    	//signatureVerificationErrors = "Firma "+Integer.toString(i+1)+ ": "+
		    		//arraySignaturesErrors.get(i).toString() + "\n";
		    }
		    
		    if (arraySignaturesErrors.isEmpty()) {
		    	signatureVerificationResult.setText("Firma Válida");
		    	Log.d("signature.verify", "NO HUBO ERROR EN LA VERIFICACION DE FIRMA");
		    	Toast.makeText(getApplicationContext(), "¡FIRMA CORRECTA!", Toast.LENGTH_SHORT).show();
		    	
		    }else{
		    	String finalErrors = "";
		    	for (int i = 0; i < signatureVerificationErrors.size(); i++ ) {
		    		finalErrors = finalErrors.concat(signatureVerificationErrors.get(i).toString());
		    		//resultAndErrors = resultAndErrors.concat("Firma: "+i+" "+sigError.get(i).toString()+"\n");
		    	}
		    	signatureVerificationResult.setText("Firma Inválida\n"+finalErrors);
		    	Log.d("************", "SI HUBO ERROR");
		    	Log.d("************", finalErrors);
		    	
		    	Toast.makeText(getApplicationContext(), "ERROR DE VERIFICACION DE FIRMA", Toast.LENGTH_SHORT).show();
		    }
		    
		    
		    //ArrayList sigError = signature.verify(sdoc, false, false);
		    //ArrayList sigError = sdoc.verify(false, false);
		    
		    // se crea el adaptador para mostrar los documentos firmados
		    ListView documentListView = (ListView) findViewById(R.id.documents_list);
			final ArrayList<DocumentFromBDOC> docs = new ArrayList<DocumentFromBDOC>();
			
			// Crear directorio ExtractedFiles donde se almacenan los archivos extraidos
			// de los contenedores BDOC
			extractedDirFiles = Environment.getExternalStorageDirectory() + "/" +
  			getResources().getString(R.string.app_name) + "/" +
  			getResources().getString(R.string.extracted_dir_files) + "/";			
			prepareDirectory();
			
			for (int i = 0; i < sdoc.countDataFiles(); i++){
		    	// obtener el DataFile
				DataFile df = sdoc.getDataFile(i);
		    	docs.add(new DocumentFromBDOC(df.getFileName()));
		    	Log.d("MIMETYPE:", df.getMimeType());
		    	// Extraer el archivo y guardarlo en /mnt/sdcard/TibisayMovil/ExtractedFiles
		    	FileOutputStream fos = new FileOutputStream(extractedDirFiles+df.getFileName());
		    	InputStream is = df.getBodyAsStream();
		    	if(is == null) {
                    Log.d("ERROR al extrarer archivo", "DataFile has no data!");
                    //return false;
		    	}
		    	byte[] data = new byte[4096];
		    	int n = 0, m = 0;
		    	while((n = is.read(data)) > 0) {
		    		fos.write(data, 0, n);
                    m += n;
		    	}
		    	fos.close();
		    	is.close();		    	
		    }
			
			DocumentFromBDOCAdapter documentAdapter = new DocumentFromBDOCAdapter(BDOCVerifyResultActivity.this, docs);
			documentListView.setAdapter(documentAdapter);
			documentListView.setOnItemClickListener(new android.widget.AdapterView.OnItemClickListener() {

				@Override
				public void onItemClick(AdapterView<?> parent, View view,
						int position, long id) {
					String absolutePathToOpen = extractedDirFiles + docs.get(position).getName();
					Toast.makeText(getApplicationContext(), getMimeType(absolutePathToOpen), Toast.LENGTH_SHORT).show();
					openIt(absolutePathToOpen, getMimeType(absolutePathToOpen));
					
					
				}
				
			});
			
			// se crea el adaptador para mostrar los firmantes del contenedor
			ListView signerListView = (ListView) findViewById(R.id.signatures_list);
			final ArrayList<SignerFromBDOC> signers = new ArrayList<SignerFromBDOC>();
			
		    for (int i = 0; i < sdoc.countSignatures(); i++){	    	
		    	Signature signatureTemp = sdoc.getSignature(i);
		    	//signers.add(new SignerFromBDOC(signatureTemp.getSubject()));
		    	
		    	String cn = SignedDoc.getCommonName(
		    			sdoc.getSignature(i).getKeyInfo().getSignersCertificate().getSubjectDN().getName());
		    	String name = sdoc.getSignature(i).getKeyInfo().getSubjectLastName();
		    	String date = sdoc.getSignature(i).getSignedProperties().getSigningTime().toString();
		    	String certificateSerial = sdoc.getSignature(i).getKeyInfo().getSignersCertificate().getSerialNumber().toString();
		    	String validFrom = sdoc.getSignature(i).getKeyInfo().getSignersCertificate().getNotBefore().toLocaleString();
		    	String validUntil = sdoc.getSignature(i).getKeyInfo().getSignersCertificate().getNotAfter().toLocaleString();
		    	String certificateIssuer = sdoc.getSignature(i).getKeyInfo().getSignersCertificate().getIssuerX500Principal().toString();
		    	
		    	// agregar el nombre comun del firmante y la fecha y la hora
		    	signers.add(new SignerFromBDOC(name, cn, date, certificateSerial, validFrom, validUntil, certificateIssuer));
		    	
		    }
		    SignerFromBDOCAdapter signerAdapter = new SignerFromBDOCAdapter(BDOCVerifyResultActivity.this, signers);
		    signerListView.setAdapter(signerAdapter);
		    signerListView.setOnItemClickListener(new android.widget.AdapterView.OnItemClickListener() {

		    	String ss = "hola mundo";
				@Override
				public void onItemClick(AdapterView<?> parent, View view,
						int position, long id) {
					
					//String signer = parent.getItemAtPosition(position).toString();
					
					Toast.makeText(getApplicationContext(), "SE DEBE MOSTRAR INFORMACIÓN DEL FIRMANTE", Toast.LENGTH_SHORT).show();
					showSignatureDetails(position, signers);
				}
				
			});
		    
			
/*		    
		    if(sigError.isEmpty()){
		    	Log.d("signature.verify", "NO HUBO ERROR EN LA VERIFICACION DE FIRMA");
		    	String res = "Numero de firmas: " + Integer.toString(sdoc.countSignatures()) + 
		    	" Numero de documentos: " + Integer.toString(sdoc.countDataFiles()) +
		    	" Perfil de firma: " + signature.getProfile() +
		    	" Sujeto: " + signature.getSubject() +
		    	" Hora: " + signature.getSignedProperties().getSigningTime().toString();
		    	Log.d("-->: ", res);
		    			    	
		    	//result.setText("Firma válida");
		    	
		    }else{
		    	Log.d("signature.verify", "SI HUBO ERROR");
		    	Log.d("signature.verify", Integer.toString(sigError.size()));
		    	
		    	String resultAndErrors = "Firma Inválida\n";
		    	
		    	for (int i=0; i<sigError.size(); i++ ){
		    		Log.d("signature.verify", sigError.get(i).toString());
		    		//resultAndErrors.concat(sigError.get(i).toString()+"\n");
		    		resultAndErrors = resultAndErrors.concat("Firma: "+i+" "+sigError.get(i).toString()+"\n");
		    		
		    		//Toast.makeText(getApplicationContext(), sigError.get(i).toString(), Toast.LENGTH_SHORT).show();
		    	}
		    	Toast.makeText(getApplicationContext(), "ERROR DE VERIFICACION DE FIRMA", Toast.LENGTH_SHORT).show();		    	
		    	//result.setText("Firma inválida");
		    	//result.setText(resultAndErrors);
		    }
*/		    
		    
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			
			//showOneButtonDialog(e.getMessage());
			
			Log.d("****exception:", e.getMessage());					
			e.printStackTrace();	
		}
		
	} // fin de doVerification(String f)
	
	
	
	

	
	
	
	

	// clase que abstrae un documento incluido dentro de un contenedor BDOC
	public class DocumentFromBDOC {
		private String mName;
		
		public DocumentFromBDOC(String name){
			mName = name;
		}
		
		public void setName(String name) {
			this.mName = name;
		}
		
		public String getName() {
			return mName;
		}	
	} // fin de clase DocumentFromBDOC
	
	// clase que abstrae el adaptador para llenar el ListView de documentos que
	// se encuentran dentro del contenedor BDOC
	private class DocumentFromBDOCAdapter extends BaseAdapter {

		private ArrayList<DocumentFromBDOC> mDocumentFromBDOCList;
		private LayoutInflater lInflater;
		
		private DocumentFromBDOCAdapter(Context context, ArrayList<DocumentFromBDOC> documents) {
			this.lInflater = LayoutInflater.from(context);
			this.mDocumentFromBDOCList = documents;
			
		}
		
		
		@Override
		public int getCount() {			
			return mDocumentFromBDOCList.size();
		}

		@Override
		public Object getItem(int position) {			
			return mDocumentFromBDOCList.get(position);
		}

		@Override
		public long getItemId(int position) {			
			return position;
		}

		@Override
		public View getView(int position, View convertView, ViewGroup parent) {
			ViewHolder container = null;
			
			if (convertView == null){
				container = new ViewHolder();
				convertView = lInflater.inflate(R.layout.document_inside_bdoc_item, null);
				
				container.filename_text = (TextView) convertView.findViewById(R.id.filename_text);
				container.filename_modified = (TextView) convertView.findViewById(R.id.filename_modified);
				container.type_image = (ImageView) convertView.findViewById(R.id.type_image);
				convertView.setTag(container);
			}else{
				container = (ViewHolder) convertView.getTag();
			}
			
			DocumentFromBDOC doc = (DocumentFromBDOC) getItem(position);
			container.filename_text.setText(doc.getName());
			container.filename_modified.setText(doc.getName());
			container.type_image.setImageResource(R.drawable.ic_archivo);
			
			return convertView;
		}
	
		
		class ViewHolder{
		      TextView filename_text;
		      TextView filename_modified;
		      ImageView type_image;
		   }
		
	}
	
	
	// class que abstrae un firmante incluido en un contenedor BDOC
	private class SignerFromBDOC {
		
		// nombre del firmante
		private String mName;
		
		// nombre comun del firmante
		private String mCN;
		
		// fecha y hora de la firma
		private String mDate;
		
		// serial del certificado
		private String mCertificateSerial;
		
		// fecha de validez inicial
		private String mValidFrom;
		
		// fecha de validez final
		private String mValidUntil;
		
		// emisor del certificado
		private String mCertificateIssuer;
		
		public SignerFromBDOC(String name, String cn, String date, String serial, String validFrom, String validUntil, String issuer){
			mName = name;
			mCN = cn;
			mDate = date;
			mCertificateSerial = serial;
			mValidFrom = validFrom;
			mValidUntil = validUntil;
			mCertificateIssuer = issuer;			
		}
		
		public void setName(String name) {
			this.mName = name;
		}
		
		public String getName() {
			return mName;
		}	
		
		public void setCN(String cn) {
			this.mCN = cn;
		}
		
		public String getCN() {
			return mCN;
		}		
		
		public void setDate(String date) {
			this.mDate = date;
		}
		
		public String getDate() {
			return mDate;
		}
		
		public void setCertificateSerial(String certSerial) {
			this.mCertificateSerial = certSerial;
		}
		
		public String getCertificateSerial() {
			return mCertificateSerial;
		}
		
		public void setValidFrom(String validFrom) {
			this.mValidFrom = validFrom;
		}
		
		public String getValidFrom() {
			return mValidFrom;
		}
		
		public void setValidUntil(String validUntil) {
			this.mValidUntil = validUntil;
		}
		
		public String getValidUntil() {
			return mValidUntil;
		}
		
		public void setCertificateIssuer(String certIssuer) {
			this.mCertificateIssuer = certIssuer;
		}
		
		public String getCertificateIssuer() {
			return mCertificateIssuer;
		}
		
	} // fin de clase SignerFromBDOC
	
	// clase que abstrae el adaptador para llenar el ListView de documentos que
	// se encuentran dentro del contenedor BDOC
	private class SignerFromBDOCAdapter extends BaseAdapter {

		private ArrayList<SignerFromBDOC> mSignerFromBDOCList;
		private LayoutInflater lInflater;
		
		private SignerFromBDOCAdapter(Context context, ArrayList<SignerFromBDOC> signers) {
			this.lInflater = LayoutInflater.from(context);
			this.mSignerFromBDOCList = signers;
			
		}
		
		
		@Override
		public int getCount() {			
			return mSignerFromBDOCList.size();
		}

		@Override
		public Object getItem(int position) {			
			return mSignerFromBDOCList.get(position);
		}

		@Override
		public long getItemId(int position) {			
			return position;
		}

		@Override
		public View getView(int position, View convertView, ViewGroup parent) {
			ViewHolder container = null;
			
			if (convertView == null){
				container = new ViewHolder();
				convertView = lInflater.inflate(R.layout.signer_inside_bdoc_item, null);
				
				container.signer_text = (TextView) convertView.findViewById(R.id.signer_text);
				container.signer_modified = (TextView) convertView.findViewById(R.id.signer_modified);
				container.type_image = (ImageView) convertView.findViewById(R.id.type_image);
				convertView.setTag(container);
			}else{
				container = (ViewHolder) convertView.getTag();
			}
			
			SignerFromBDOC doc = (SignerFromBDOC) getItem(position);
			container.signer_text.setText(doc.getName());
			container.signer_modified.setText(doc.getName());
			container.type_image.setImageResource(R.drawable.ic_pluma);
			
			return convertView;
		}
	
		
		class ViewHolder{
		      TextView signer_text;
		      TextView signer_modified;
		      ImageView type_image;
		   }
		
	}
	
	
	/**
     * Prepara directorio
     * @return boolean
     */
    private boolean prepareDirectory() 
    {
        try
        {
            if (makedirs()) 
            {
                return true;
            } else {
                return false;
            }
        } catch (Exception e) 
        {
            e.printStackTrace();
            Toast.makeText(this, "Could not initiate File System.. Is Sdcard mounted properly?", Toast.LENGTH_LONG).show();
            return false;
        }
    }
 
    /**
     * Crea directorio utilizando la variable tmpDir
     * @return boolean
     */
    private boolean makedirs() 
    {
        File tempdir = new File(extractedDirFiles);
        if (!tempdir.exists())
            tempdir.mkdirs();
 
//        if (tempdir.isDirectory()) 
//        {
//            File[] files = tempdir.listFiles();
//            for (File file : files) 
//            {
//                if (!file.delete()) 
//                {
//                    System.out.println("Failed to delete " + file);
//                }
//            }
//        }
        return (tempdir.isDirectory());
    }
	
    // funcion para lanzar un intent que abra un archivo
    private void openIt(String filePath, String mimeType) {
		
		Intent shareIntent = new Intent();
		shareIntent.setAction(Intent.ACTION_VIEW);
		File file = new File(filePath);
		Uri uri = Uri.fromFile(file);
		Log.i("DEBUG", file.getPath());
		shareIntent.setDataAndType(uri, mimeType);		
		startActivity(Intent.createChooser(shareIntent, getResources().getText(R.string.open_it_using)));
	}
    
    // funcion para obtener el tipo mime de un archivo
    public static String getMimeType(String url)
    {
        String extension = url.substring(url.lastIndexOf("."));
        String mimeTypeMap = MimeTypeMap.getFileExtensionFromUrl(extension);
        String mimeType = MimeTypeMap.getSingleton().getMimeTypeFromExtension(mimeTypeMap);
        return mimeType;
    }
    
    // funcion para compartir el documento
	private void shareIt() {
		
		Intent shareIntent = new Intent();
		shareIntent.setAction(Intent.ACTION_SEND);
		File file = new File(fileToVerify);
		
		
		Uri uri = Uri.fromFile(file);
		Log.i("DEBUG", file.getPath());
		//Log.d("******", getMimeType(file.getPath()));
		//shareIntent.setDataAndType(uri, getMimeType(file.getPath()));
		shareIntent.putExtra(Intent.EXTRA_STREAM, uri);
		shareIntent.setType("application/*");
		startActivity(Intent.createChooser(shareIntent, getResources().getText(R.string.share_it_using)));
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.bdocverify_result, menu);
		return true;
	}
    
	private void showSignatureDetails(int position, ArrayList<SignerFromBDOC> signers) {
		
		Log.d("**showSignatureDetails", Integer.toString(position));
		Log.d("** nombre", signers.get(position).getName());
		Intent intent = new Intent(this, ActivitySignerInfo.class);
		
		intent.putExtra("name", signers.get(position).getName());
		intent.putExtra("cn", signers.get(position).getCN());
		intent.putExtra("date", signers.get(position).getDate());
		intent.putExtra("certificateSerial", signers.get(position).getCertificateSerial());
		intent.putExtra("validFrom", signers.get(position).getValidFrom());
		intent.putExtra("validUntil", signers.get(position).getValidUntil());
		intent.putExtra("certificateIssuer", signers.get(position).getCertificateIssuer());
		startActivity(intent);
	}
	
}




